library entity;

import 'dart:html' show ImageElement;
import 'package:empirical/empirical.dart';

part 'living_entity.dart';

class Entity {
  ImageElement sprite;
  num x = 10, y = 10;
  num width = 20, height = 20;
  bool dead = false;
  
  Entity(String spriteSrc) : sprite = new ImageElement(src: 'sprite\\${spriteSrc}');
  
  bool outOfBounds() {
    return xOutOfBounds() || yOutOfBounds();
  }
  
  bool xOutOfBounds() {
    return x < 0 || x > canvas.width;
  }
  
  bool yOutOfBounds() {
    return y < 0 || y > canvas.width;
  }
  
  draw() {
    context.drawImageScaled(sprite, x, y, width, height);
  }
}