part of lunaris;

class Drone extends LiveEntity {
  String DRONE_SPRITE = 'drone.gif';
  bool shieldCharged = false;
  
  Drone() : super('drone.gif') {
    randomCoordinates();
  }
  
  Drone.upgrade(String newSprite) : super(newSprite) {
    randomCoordinates();
  }
  
  randomCoordinates() {
    x = random.nextInt(canvas.width.toInt());
    y = random.nextInt(canvas.height.toInt());
  }
  
  engorge(LivingEntity defeated) {
    maxHealth += 20;
    healTo(_health + 20);
    width += (defeated.width / 15).toInt();
    height += (defeated.height / 15).toInt();
    speed += defeated.speed / 7;
  }
  
  draw() {
    super.draw();
    if (shieldCharged) {
      context.strokeStyle = 'white';
      context.beginPath();
      context.arc(x + width / 2, y + height / 2, width * 1.5, 0, 2*PI);
      context.stroke();
    }
  }
  
  move() {
    switch(random.nextInt(5)) {
      case 0:
        y -= speed;
        break;
      case 1:
        x -= speed;
        break;
      case 2:
        y += speed;
        break;
      case 3:
        x += speed;
        break;
      case 4:
        if (random.nextInt(100) != 0) return;
        shieldAttack();
        break;
    }
  }
  
  shieldAttack() {
    shieldCharged = !shieldCharged;
  }
}
