library lunaris;

import 'dart:html';
import 'dart:math' show Random, PI;
import 'package:meta/meta.dart';
import 'package:empirical/empirical.dart';

import '../entity/entity.dart';

part 'game/player.dart';
part 'game/player_drone.dart';
part 'game/cleaver_drone.dart';
part 'game/drone.dart';
part 'game/live_entity.dart';
part 'game/station.dart';

void main() {
  new Lunaris();
}

const CUSTOM_MAIN = const MainMenu('''
<h1> Lunraris </h1>
<a id="startbutton"> Start </a>
<a id="optionsbutton"> Options </a>
<a id="exitbutton"> Exit </a>
''');

const UP = 38;
const LEFT = 37;
const DOWN = 40;
const RIGHT = 39;
const SPACE = 32;

const W = 87;
const A = 65;
const S = 83;
const D = 68;

final Random random = new Random();

class Lunaris extends Empirical {
  final station = new Station();
  
  @override
  loadInterface() {
    loadMenu(CUSTOM_MAIN);
    super.loadInterface();
  }
  
  @override
  startGame() {
    station.start();
  }
  
  @override
  pauseGame() {
    
  }
  
  @override
  endGame() {
    station.end();
  }
  
  @override
  tickGame() {
    station.keyInput(keys);
    station.droneLogic();
  }
  
  @override
  drawGame() {
    station.draw();
  }
  
  @override
  resizeGame() {
    station.resize();
  }
  
  @override
  clickGame(num x, num y) {
    
  }
  
}
